Imports Microsoft.Win32

Public Class frmSetSettings

	Dim regFolder As String = "Software\VB and VBA Program Settings\"
	Dim initApp As String = ""
	Dim appName, alls(,), s() As String
	Dim idx As Short

	Private Sub frmSetSettings_Load(sender As Object, e As EventArgs) _
		Handles MyBase.Load
		' alle KeyNamen aus dem VB-Folder der Registry auslesen
		' und in Listbox speichern
		Dim regkey As RegistryKey = Registry.CurrentUser.OpenSubKey(regFolder)
		Dim names As String() = regkey.GetSubKeyNames()
		progNames.Items.AddRange(names)
		If initApp <> "" Then   ' ist ein Appname definiert?
			progNames.SelectedItem = initApp
		Else
			progNames.SelectedIndex = 0
		End If
		SetListBoxTabs(ListBox1, {48, 96})  'die Tabulatoren in Listbox definieren
		idx = 0
		ListBox2.SelectedIndex = idx
		btnAll.Select()
	End Sub

	Private Sub progNames_SelectedIndexChanged(sender As Object, e As EventArgs) _
		Handles progNames.SelectedIndexChanged
		' bei Auswahl eines Application-Namen alle Daten dazu
		' aus Registry lesen und anzeigen
		btnDelete.PerformClick()   'lschen aller Eingabe-Controls
		appName = progNames.SelectedItem
		idx = 0
		btnAll.PerformClick()
	End Sub

	Private Sub progNames_DropDownClosed(sender As Object, e As EventArgs) _
		Handles progNames.DropDownClosed
		SendKeys.Send("{HOME}")
	End Sub

	Private Sub btnAll_Click(sender As Object, e As EventArgs) _
		Handles btnAll.Click
		' bei Klick eines Application-Namen alle Daten dazu
		' aus Registry lesen und anzeigen
		GetAllSections(appName)  'alle Sections zu einem Key lesen
		txtSection.Text = ListBox2.Items(idx)
		alls = GetAllSettings(appName, txtSection.Text)  'alle Settings einer Section lesen
		ListBox1.Items.Clear()
		' Listbox fllen mit Daten einer Section
		For i As Short = 0 To alls.Length / 2 - 1
			ListBox1.Items.Add(alls(i, 0) & vbTab & Trim(alls(i, 1)))
		Next
	End Sub

	Private Sub btnDelete_Click(sender As Object, e As EventArgs) _
		Handles btnDelete.Click
		' Eingabecontrols lschen
		ListBox1.Items.Clear()
		ListBox2.Items.Clear()
		For Each c As Control In Controls
			If TypeOf c Is TextBox Then c.Text = ""
		Next
	End Sub

	Private Sub btnStore_Click(sender As Object, e As EventArgs) _
		Handles btnStore.Click
		' ein gendertes Setting speichern
		SaveSetting(appName, txtSection.Text, txtKey.Text, txtSetting.Text)
	End Sub

	Private Sub btnRead_Click(sender As Object, e As EventArgs)
		' ein bestimmtes Setting lesen
		txtSetting.Text = GetSetting(appName, txtSection.Text, txtKey.Text)
	End Sub

	Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) _
		Handles ListBox1.SelectedIndexChanged
		' Listbox-Eintrag auf Textboxen aufteilen
		' (fr eventuelles ndern eines Setting)
		If ListBox1.SelectedItems.Count = 0 Then Exit Sub
		s = Split(ListBox1.SelectedItem, vbTab)
		txtKey.Text = s(0)
		txtSetting.Text = s(1)
	End Sub

	Private Sub ListBox1_Leave(sender As Object, e As EventArgs) _
		Handles ListBox1.Leave
		ListBox1.ClearSelected()
	End Sub

	Private Sub ListBox2_SelectedIndexChanged(sender As Object, e As EventArgs) _
		Handles ListBox2.SelectedIndexChanged
		' zur Section gehrige Daten auslesen und anzeigen
		txtKey.Text = ""
		txtSetting.Text = ""
		idx = ListBox2.SelectedIndex
		btnAll.PerformClick()
	End Sub

	Private Sub GetAllSections(appName As String)
		' Prozedur zur Ermittlung aller Sections, 
		' die zu einem Key (einer Application) gehren
		Dim regKey As RegistryKey _
			= Registry.CurrentUser.OpenSubKey(regFolder + appName,
				RegistryKeyPermissionCheck.ReadSubTree)
		If IsNothing(regKey) Then
			btnDelete.PerformClick()
		Else
			ListBox2.Items.Clear()
			ListBox2.Items.AddRange(regKey.GetSubKeyNames())   'alle Sections in Listbox anzeigen
		End If
	End Sub

	Private Sub SetListBoxTabs(lst As ListBox, tabs As IList(Of Integer))
		Dim offsets As ListBox.IntegerCollection
		' Tabstops verfgbar machen fr die Listbox
		With lst
			.UseTabStops = True
			.UseCustomTabOffsets = True
			' lesen der Tabstop-Positionen
			offsets = .CustomTabOffsets
		End With
		' definieren der individuellen Tabstops
		For Each tab As Integer In tabs
			offsets.Add(tab)
		Next tab
	End Sub

End Class
